#!/usr/bin/env python
from __future__ import division
from rtlsdr import *
from pylab import *
from time import time
import sys


#directory = '/home/superkuh/www/gnuradio/live'

# this script creates spectrograms and log files, all put into the above directory.
# The spectrograms are named by frequency. The logs come in both per frequency and
# an "all.log" format.

def main():
        myfreq = int(sys.argv[1])
	mysrate = int(sys.argv[2])
	mygain = int(sys.argv[3])
	myoffset = 0 # default
	myoffset = int(sys.argv[4])
	directory = '/home/superkuh/www/gnuradio/live'
	directory = sys.argv[5]
#	print 'debug: ' + str(myfreq) + ',' + str(mysrate) + ',' + str(mygain) + ',' + str(myoffset)

        sdr = RtlSdr()

        sdr.rs = mysrate
        sdr.fc = myfreq
	sdr.err_ppm = myoffset
        sdr.gain = mygain

        print '  sample rate: %0.6f MHz' % (sdr.rs/1e6)
        print 'Center frequency %0.6f MHz' % (sdr.fc/1e6)
        print '  gain: %d dB' % sdr.gain
	print '  ppm correction: %d ppm' % sdr.err_ppm

        samples = sdr.read_samples(256*1024)
	
	logfile = directory + '/' + str(myfreq) + '.log'
	f = open(logfile, 'a+')
	f.write( str(time()) + ' , ' + '%0.2f' % (10*log10(var(samples))) + ' , ' + str(sdr.gain) + ' , ' + str(sdr.err_ppm) + '\n')

	logfile2 = directory + '/' + 'all.log'
	f = open(logfile2, 'a+')
	f.write( str(time()) + ' ' + str(myfreq) + ' ' + '%0.2f' % (10*log10(var(samples))) + ' ' + str(sdr.gain) + ' ' + str(sdr.err_ppm) + '\n')

        try:
                import pylab as mpl

#		mpl.psd(samples, NFFT=1024, Fc=sdr.fc/1e6, Fs=sdr.rs/1e6)
#                mpl.show()

                mpl.figure()
                fig = mpl.figure()
		if sdr.fc > 1000000000:
			# http://matplotlib.org/api/ticker_api.html#matplotlib.ticker.ScalarFormatter
			# mpl.psd(samples, NFFT=1024, Fc=sdr.fc/1e7, Fs=sdr.rs/1e6)
			# higher freqs are boring, and until I figure out how to fix the charts I'll
			# disable figure production to save rsync bandwidth.
			print 'skipping >1 Ghz spectrogram'
			pass
		else:
			mpl.psd(samples, NFFT=1024, Fc=sdr.fc/1e6, Fs=sdr.rs/1e6)
			filename = str(myfreq)
			filename += '.png'
			filename = directory + '/' + filename
			fig.savefig(filename)
        except:
                # matplotlib not installed/working
		print 'failed matplotlib'
                pass

        print 'Done\n'
        sdr.close()

# really? um, I guess this was for the async callback stuff which I don't understand.
if __name__ == '__main__':
    main()

#@limit_calls(2)
#def test_callback(samples, rtlsdr_obj):
#    print '  in callback'
#    print '  signal mean:', sum(samples)/len(samples)
#        print 'Testing callback...'
#        sdr.read_samples_async(test_callback, 256*1024)

